diff --git a/gplugin-gtk-viewer/gplugin-gtk-viewer.c b/gplugin-gtk-viewer/gplugin-gtk-viewer.c
--- a/gplugin-gtk-viewer/gplugin-gtk-viewer.c
+++ b/gplugin-gtk-viewer/gplugin-gtk-viewer.c
@@ -181,6 +181,7 @@
 gint
 main(gint argc, gchar **argv)
 {
+	GPluginManager *manager = NULL;
 	GError *error = NULL;
 	GOptionContext *ctx = NULL;
 	GtkWidget *window = NULL;
@@ -209,17 +210,19 @@
 
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
 
+	manager = gplugin_manager_get_default();
+
 	if(add_default_paths)
-		gplugin_manager_add_default_paths();
+		gplugin_manager_add_default_paths(manager);
 
 	if(paths) {
 		gint i;
 
 		for(i = 0; paths[i]; i++)
-			gplugin_manager_prepend_path(paths[i]);
+			gplugin_manager_prepend_path(manager, paths[i]);
 	}
 
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 
 	/* now create and show the window */
 	window = create_window();
diff --git a/gplugin-gtk/gplugin-gtk-store.c b/gplugin-gtk/gplugin-gtk-store.c
--- a/gplugin-gtk/gplugin-gtk-store.c
+++ b/gplugin-gtk/gplugin-gtk-store.c
@@ -128,9 +128,12 @@
 static void
 gplugin_gtk_store_add_plugin_by_id(GPluginGtkStore *store, const gchar *id)
 {
+	GPluginManager *manager = NULL;
 	GSList *plugins = NULL, *l = NULL;
 
-	plugins = gplugin_manager_find_plugins(id);
+	manager = gplugin_manager_get_default();
+
+	plugins = gplugin_manager_find_plugins(manager, id);
 	for(l = plugins; l; l = l->next)
 		gplugin_gtk_store_add_plugin(store, GPLUGIN_PLUGIN(l->data));
 	g_slist_free_full(plugins, g_object_unref);
@@ -234,14 +237,15 @@
 
 	G_OBJECT_CLASS(gplugin_gtk_store_parent_class)->constructed(obj);
 
-	ids = gplugin_manager_list_plugins();
+	manager = gplugin_manager_get_default();
+
+	ids = gplugin_manager_list_plugins(manager);
 	for(l = ids; l; l = l->next)
 		gplugin_gtk_store_add_plugin_by_id(
 			GPLUGIN_GTK_STORE(obj),
 			(const gchar *)l->data);
 	g_list_free(ids);
 
-	manager = gplugin_manager_get_instance();
 	g_signal_connect_object(
 		manager,
 		"loaded-plugin",
diff --git a/gplugin-gtk/gplugin-gtk-view.c b/gplugin-gtk/gplugin-gtk-view.c
--- a/gplugin-gtk/gplugin-gtk-view.c
+++ b/gplugin-gtk/gplugin-gtk-view.c
@@ -71,12 +71,15 @@
 	gpointer data)
 {
 	GPluginGtkView *view = GPLUGIN_GTK_VIEW(data);
+	GPluginManager *manager = NULL;
 	GPluginPlugin *plugin = NULL;
 	GPluginPluginState state;
 	GtkTreeModel *model = NULL;
 	GtkTreeIter iter;
 	GtkTreePath *tree_path = NULL;
 
+	manager = gplugin_manager_get_default();
+
 	tree_path = gtk_tree_path_new_from_string(path);
 
 	model = gtk_tree_view_get_model(GTK_TREE_VIEW(view));
@@ -98,7 +101,7 @@
 	if(state == GPLUGIN_PLUGIN_STATE_LOADED) {
 		GError *error = NULL;
 
-		gplugin_manager_unload_plugin(plugin, &error);
+		gplugin_manager_unload_plugin(manager, plugin, &error);
 
 		if(error != NULL) {
 			g_warning("Failed to unload plugin: %s", error->message);
@@ -108,7 +111,7 @@
 	} else {
 		GError *error = NULL;
 
-		gplugin_manager_load_plugin(plugin, &error);
+		gplugin_manager_load_plugin(manager, plugin, &error);
 
 		if(error != NULL) {
 			g_warning("Failed to load plugin: %s", error->message);
diff --git a/gplugin-query/gplugin-query.c b/gplugin-query/gplugin-query.c
--- a/gplugin-query/gplugin-query.c
+++ b/gplugin-query/gplugin-query.c
@@ -100,6 +100,7 @@
 static gboolean
 output_plugin(const gchar *id)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GSList *plugins = NULL, *l = NULL;
 	gboolean first = TRUE, header_output = FALSE;
 
@@ -108,7 +109,7 @@
 #define MAIN_FORMAT MAIN_FORMAT_NEL "%s\n"
 #define STR_OR_EMPTY(str) ((str) ? (str) : "")
 
-	plugins = gplugin_manager_find_plugins(id);
+	plugins = gplugin_manager_find_plugins(manager, id);
 	if(plugins == NULL) {
 		printf("%s not found\n", id);
 
@@ -291,6 +292,7 @@
 gint
 main(gint argc, gchar **argv)
 {
+	GPluginManager *manager = NULL;
 	GError *error = NULL;
 	GOptionContext *ctx = NULL;
 	GOptionGroup *group = NULL;
@@ -322,10 +324,13 @@
 	 */
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
 
+	manager = gplugin_manager_get_default();
+
 	if(output_paths) {
 		GList *path = NULL;
 
-		for(path = gplugin_manager_get_paths(); path; path = path->next) {
+		for(path = gplugin_manager_get_paths(manager); path;
+			path = path->next) {
 			printf("%s\n", (gchar *)path->data);
 		}
 
@@ -338,7 +343,7 @@
 		return 0;
 	}
 
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 
 	/* check if the user gave us atleast one plugin, and output them */
 	if(argc > 1) {
@@ -359,7 +364,7 @@
 
 		g_queue_free(plugins);
 	} else {
-		GList *plugins = gplugin_manager_list_plugins();
+		GList *plugins = gplugin_manager_list_plugins(manager);
 
 		if(!output_plugins(plugins))
 			ret = EXIT_FAILURE;
diff --git a/gplugin/gplugin-loader-tests.c b/gplugin/gplugin-loader-tests.c
--- a/gplugin/gplugin-loader-tests.c
+++ b/gplugin/gplugin-loader-tests.c
@@ -36,6 +36,7 @@
 static void
 gplugin_test_loader_full(gconstpointer d)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GPluginPluginInfo *info = NULL;
 	GError *error = NULL;
@@ -45,7 +46,7 @@
 	gint i;
 
 	id = g_strdup_printf("gplugin/%s-basic-plugin", (const gchar *)d);
-	plugin = gplugin_manager_find_plugin(id);
+	plugin = gplugin_manager_find_plugin(manager, id);
 	g_assert_nonnull(plugin);
 
 	info = gplugin_plugin_get_info(plugin);
@@ -78,14 +79,14 @@
 		==,
 		GPLUGIN_PLUGIN_STATE_QUERIED);
 
-	gplugin_manager_load_plugin(plugin, &error);
+	gplugin_manager_load_plugin(manager, plugin, &error);
 	g_assert_no_error(error);
 	g_assert_cmpint(
 		gplugin_plugin_get_state(plugin),
 		==,
 		GPLUGIN_PLUGIN_STATE_LOADED);
 
-	gplugin_manager_unload_plugin(plugin, &error);
+	gplugin_manager_unload_plugin(manager, plugin, &error);
 	g_assert_no_error(error);
 	g_assert_cmpint(
 		gplugin_plugin_get_state(plugin),
@@ -98,17 +99,18 @@
 static void
 gplugin_test_loader_load_failed(gconstpointer d)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GError *error = NULL;
 	gchar *id = NULL;
 	gboolean ret = FALSE;
 
 	id = g_strdup_printf("gplugin/%s-load-failed", (const gchar *)d);
-	plugin = gplugin_manager_find_plugin(id);
+	plugin = gplugin_manager_find_plugin(manager, id);
 	g_free(id);
 	g_assert_nonnull(plugin);
 
-	ret = gplugin_manager_load_plugin(plugin, &error);
+	ret = gplugin_manager_load_plugin(manager, plugin, &error);
 	g_assert_false(ret);
 
 	g_assert_error(error, GPLUGIN_DOMAIN, 0);
@@ -130,17 +132,18 @@
 static void
 gplugin_test_loader_load_exception(gconstpointer d)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GError *error = NULL;
 	gchar *id = NULL;
 	gboolean ret = FALSE;
 
 	id = g_strdup_printf("gplugin/%s-load-exception", (const gchar *)d);
-	plugin = gplugin_manager_find_plugin(id);
+	plugin = gplugin_manager_find_plugin(manager, id);
 	g_free(id);
 	g_assert_nonnull(plugin);
 
-	ret = gplugin_manager_load_plugin(plugin, &error);
+	ret = gplugin_manager_load_plugin(manager, plugin, &error);
 	g_assert_false(ret);
 
 	g_assert_error(error, GPLUGIN_DOMAIN, 0);
@@ -162,17 +165,18 @@
 static void
 gplugin_test_loader_unload_failed(gconstpointer d)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GError *error = NULL;
 	gchar *id = NULL;
 	gboolean ret = FALSE;
 
 	id = g_strdup_printf("gplugin/%s-unload-failed", (const gchar *)d);
-	plugin = gplugin_manager_find_plugin(id);
+	plugin = gplugin_manager_find_plugin(manager, id);
 	g_free(id);
 	g_assert_nonnull(plugin);
 
-	ret = gplugin_manager_load_plugin(plugin, &error);
+	ret = gplugin_manager_load_plugin(manager, plugin, &error);
 	g_assert_no_error(error);
 	g_assert_true(ret);
 	g_assert_cmpint(
@@ -180,7 +184,7 @@
 		==,
 		GPLUGIN_PLUGIN_STATE_LOADED);
 
-	ret = gplugin_manager_unload_plugin(plugin, &error);
+	ret = gplugin_manager_unload_plugin(manager, plugin, &error);
 	g_assert_false(ret);
 
 	g_assert_error(error, GPLUGIN_DOMAIN, 0);
@@ -202,6 +206,7 @@
 static void
 gplugin_test_loader_dependencies(gconstpointer d)
 {
+	GPluginManager *manager = gplugin_manager_get_default();
 	GPluginPlugin *plugin = NULL;
 	GPluginPluginInfo *info = NULL;
 	gchar *id = NULL;
@@ -210,7 +215,7 @@
 	gint i = 0;
 
 	id = g_strdup_printf("gplugin/%s-dependent-plugin", (const gchar *)d);
-	plugin = gplugin_manager_find_plugin(id);
+	plugin = gplugin_manager_find_plugin(manager, id);
 	g_free(id);
 	g_assert_nonnull(plugin);
 
@@ -256,17 +261,23 @@
 	const gchar *plugin_dir,
 	const gchar *short_name)
 {
+	GPluginManager *manager = NULL;
+
 	gplugin_init(GPLUGIN_CORE_FLAGS_NONE);
 
+	manager = gplugin_manager_get_default();
+
 	g_setenv("GI_TYPELIB_PATH", GI_TYPELIB_PATH, TRUE);
 
-	if(loader_dir)
-		gplugin_manager_append_path(loader_dir);
+	if(loader_dir) {
+		gplugin_manager_append_path(manager, loader_dir);
+	}
 
-	if(plugin_dir)
-		gplugin_manager_append_path(plugin_dir);
+	if(plugin_dir) {
+		gplugin_manager_append_path(manager, plugin_dir);
+	}
 
-	gplugin_manager_refresh();
+	gplugin_manager_refresh(manager);
 
 	gplugin_loader_tests_add_tests(short_name);
 }
diff --git a/gplugin/gplugin-manager.h b/gplugin/gplugin-manager.h
--- a/gplugin/gplugin-manager.h
+++ b/gplugin/gplugin-manager.h
@@ -46,50 +46,6 @@
 	/*< private >*/
 	GObjectClass parent;
 
-	/*< public >*/
-	void (*append_path)(GPluginManager *manager, const gchar *path);
-	void (*prepend_path)(GPluginManager *manager, const gchar *path);
-	void (*remove_path)(GPluginManager *manager, const gchar *path);
-	void (*remove_paths)(GPluginManager *manager);
-
-	GList *(*get_paths)(GPluginManager *manager);
-
-	gboolean (
-		*register_loader)(GPluginManager *manager, GType type, GError **error);
-	gboolean (*unregister_loader)(
-		GPluginManager *manager,
-		GType type,
-		GError **error);
-	GSList *(*get_loaders)(GPluginManager *manager);
-
-	void (*refresh)(GPluginManager *manager);
-
-	void (*foreach)(
-		GPluginManager *manager,
-		GPluginManagerForeachFunc func,
-		gpointer data);
-
-	GSList *(*find_plugins)(GPluginManager *manager, const gchar *id);
-	GSList *(*find_plugins_with_state)(
-		GPluginManager *manager,
-		GPluginPluginState state);
-
-	GList *(*list_plugins)(GPluginManager *manager);
-
-	GSList *(*get_plugin_dependencies)(
-		GPluginManager *manager,
-		GPluginPlugin *plugin,
-		GError **error);
-
-	gboolean (*load_plugin)(
-		GPluginManager *manager,
-		GPluginPlugin *plugin,
-		GError **error);
-	gboolean (*unload_plugin)(
-		GPluginManager *manager,
-		GPluginPlugin *plugin,
-		GError **error);
-
 	/* signals */
 	gboolean (*loading_plugin)(
 		GPluginManager *manager,
@@ -109,44 +65,70 @@
 	gpointer reserved[8];
 };
 
-void gplugin_manager_append_path(const gchar *path);
-void gplugin_manager_prepend_path(const gchar *path);
-void gplugin_manager_remove_path(const gchar *path);
-void gplugin_manager_remove_paths(void);
+void gplugin_manager_append_path(GPluginManager *manager, const gchar *path);
+void gplugin_manager_prepend_path(GPluginManager *manager, const gchar *path);
+void gplugin_manager_remove_path(GPluginManager *manager, const gchar *path);
+void gplugin_manager_remove_paths(GPluginManager *manager);
 
-void gplugin_manager_add_default_paths(void);
-void gplugin_manager_add_app_paths(const gchar *prefix, const gchar *appname);
+void gplugin_manager_add_default_paths(GPluginManager *manager);
+void gplugin_manager_add_app_paths(
+	GPluginManager *manager,
+	const gchar *prefix,
+	const gchar *appname);
 
-GList *gplugin_manager_get_paths(void);
+GList *gplugin_manager_get_paths(GPluginManager *manager);
 
-gboolean gplugin_manager_register_loader(GType type, GError **error);
-gboolean gplugin_manager_unregister_loader(GType type, GError **error);
-GSList *gplugin_manager_get_loaders(void);
+gboolean gplugin_manager_register_loader(
+	GPluginManager *manager,
+	GType type,
+	GError **error);
+gboolean gplugin_manager_unregister_loader(
+	GPluginManager *manager,
+	GType type,
+	GError **error);
+GSList *gplugin_manager_get_loaders(GPluginManager *manager);
 
-void gplugin_manager_refresh(void);
+void gplugin_manager_refresh(GPluginManager *manager);
 
-void gplugin_manager_foreach(GPluginManagerForeachFunc func, gpointer data);
+void gplugin_manager_foreach(
+	GPluginManager *manager,
+	GPluginManagerForeachFunc func,
+	gpointer data);
 
-GSList *gplugin_manager_find_plugins(const gchar *id);
+GSList *gplugin_manager_find_plugins(GPluginManager *manager, const gchar *id);
 GSList *gplugin_manager_find_plugins_with_version(
+	GPluginManager *manager,
 	const gchar *id,
 	const gchar *op,
 	const gchar *version);
-GSList *gplugin_manager_find_plugins_with_state(GPluginPluginState state);
+GSList *gplugin_manager_find_plugins_with_state(
+	GPluginManager *manager,
+	GPluginPluginState state);
 
-GPluginPlugin *gplugin_manager_find_plugin(const gchar *id);
-GPluginPlugin *gplugin_manager_find_plugin_with_newest_version(const gchar *id);
+GPluginPlugin *gplugin_manager_find_plugin(
+	GPluginManager *manager,
+	const gchar *id);
+GPluginPlugin *gplugin_manager_find_plugin_with_newest_version(
+	GPluginManager *manager,
+	const gchar *id);
 
 GSList *gplugin_manager_get_plugin_dependencies(
+	GPluginManager *manager,
 	GPluginPlugin *plugin,
 	GError **error);
 
-gboolean gplugin_manager_load_plugin(GPluginPlugin *plugin, GError **error);
-gboolean gplugin_manager_unload_plugin(GPluginPlugin *plugin, GError **error);
+gboolean gplugin_manager_load_plugin(
+	GPluginManager *manager,
+	GPluginPlugin *plugin,
+	GError **error);
+gboolean gplugin_manager_unload_plugin(
+	GPluginManager *manager,
+	GPluginPlugin *plugin,
+	GError **error);
 
-GList *gplugin_manager_list_plugins(void);
+GList *gplugin_manager_list_plugins(GPluginManager *manager);
 
-GPluginManager *gplugin_manager_get_instance(void);
+GPluginManager *gplugin_manager_get_default(void);
 
 G_END_DECLS
 
